package java.lang;

import java.io.Serializable;

public final class Boolean implements Serializable {
   public static final Boolean TRUE = new Boolean(true);
   public static final Boolean FALSE = new Boolean(false);
   public static final Class TYPE = Class.getPrimitiveClass("boolean");
   private boolean value;
   private static final long serialVersionUID = -3665804199014368530L;

   public Boolean(boolean var1) {
      this.value = var1;
   }

   public Boolean(String var1) {
      this(toBoolean(var1));
   }

   public boolean booleanValue() {
      return this.value;
   }

   public static Boolean valueOf(String var0) {
      return new Boolean(toBoolean(var0));
   }

   public String toString() {
      return this.value ? "true" : "false";
   }

   public int hashCode() {
      return this.value ? 1231 : 1237;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Boolean) {
         return this.value == (Boolean)var1;
      } else {
         return false;
      }
   }

   public static boolean getBoolean(String var0) {
      return toBoolean(System.getProperty(var0));
   }

   private static boolean toBoolean(String var0) {
      return var0 != null && var0.toLowerCase().equals("true");
   }
}
