package java.lang;

public final class Byte extends Number {
   public static final byte MIN_VALUE = -128;
   public static final byte MAX_VALUE = 127;
   public static final Class TYPE = Class.getPrimitiveClass("byte");
   private byte value;

   public static String toString(byte var0) {
      return Integer.toString(var0, 10);
   }

   public static byte parseByte(String var0) throws NumberFormatException {
      return parseByte(var0, 10);
   }

   public static byte parseByte(String var0, int var1) throws NumberFormatException {
      int var2 = Integer.parseInt(var0, var1);
      if (var2 >= -128 && var2 <= 127) {
         return (byte)var2;
      } else {
         throw new NumberFormatException();
      }
   }

   public static Byte valueOf(String var0, int var1) throws NumberFormatException {
      return new Byte(parseByte(var0, var1));
   }

   public static Byte valueOf(String var0) throws NumberFormatException {
      return valueOf(var0, 10);
   }

   public static Byte decode(String var0) throws NumberFormatException {
      if (var0.startsWith("0x")) {
         return valueOf(var0.substring(2), 16);
      } else if (var0.startsWith("#")) {
         return valueOf(var0.substring(1), 16);
      } else {
         return var0.startsWith("0") && var0.length() > 1 ? valueOf(var0.substring(1), 8) : valueOf(var0);
      }
   }

   public Byte(byte var1) {
      this.value = var1;
   }

   public Byte(String var1) throws NumberFormatException {
      this.value = parseByte(var1);
   }

   public byte byteValue() {
      return this.value;
   }

   public short shortValue() {
      return (short)this.value;
   }

   public int intValue() {
      return this.value;
   }

   public long longValue() {
      return (long)this.value;
   }

   public float floatValue() {
      return (float)this.value;
   }

   public double doubleValue() {
      return (double)this.value;
   }

   public String toString() {
      return String.valueOf(this.value);
   }

   public int hashCode() {
      return this.value;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Byte) {
         return this.value == (Byte)var1;
      } else {
         return false;
      }
   }
}
