package java.lang;

public final class Float extends Number {
   public static final float POSITIVE_INFINITY = InfinityF;
   public static final float NEGATIVE_INFINITY = -InfinityF;
   public static final float NaN = NaNF;
   public static final float MAX_VALUE = 3.4028235E38F;
   public static final float MIN_VALUE = 1.4E-45F;
   public static final Class TYPE = Class.getPrimitiveClass("float");
   private float value;
   private static final long serialVersionUID = -2671257302660747028L;

   public static String toString(float var0) {
      return (new FloatingDecimal(var0)).toJavaFormatString();
   }

   public static Float valueOf(String var0) throws NumberFormatException {
      return new Float(Double.valueOf0(var0));
   }

   public static boolean isNaN(float var0) {
      return var0 != var0;
   }

   public static boolean isInfinite(float var0) {
      return var0 == POSITIVE_INFINITY || var0 == NEGATIVE_INFINITY;
   }

   public Float(float var1) {
      this.value = var1;
   }

   public Float(double var1) {
      this.value = (float)var1;
   }

   public Float(String var1) throws NumberFormatException {
      this(valueOf(var1));
   }

   public boolean isNaN() {
      return isNaN(this.value);
   }

   public boolean isInfinite() {
      return isInfinite(this.value);
   }

   public String toString() {
      return String.valueOf(this.value);
   }

   public byte byteValue() {
      return (byte)((int)this.value);
   }

   public short shortValue() {
      return (short)((int)this.value);
   }

   public int intValue() {
      return (int)this.value;
   }

   public long longValue() {
      return (long)this.value;
   }

   public float floatValue() {
      return this.value;
   }

   public double doubleValue() {
      return (double)this.value;
   }

   public int hashCode() {
      return floatToIntBits(this.value);
   }

   public boolean equals(Object var1) {
      return var1 != null && var1 instanceof Float && floatToIntBits(((Float)var1).value) == floatToIntBits(this.value);
   }

   public static native int floatToIntBits(float var0);

   public static native float intBitsToFloat(int var0);
}
