package java.lang;

import java.io.FileDescriptor;
import java.net.InetAddress;

public abstract class SecurityManager {
   protected boolean inCheck;
   private boolean initialized = false;

   public boolean getInCheck() {
      return this.inCheck;
   }

   protected SecurityManager() {
      if (System.getSecurityManager() != null) {
         throw new SecurityException("security manager already installed.");
      } else {
         this.initialized = true;
      }
   }

   protected native Class[] getClassContext();

   protected native ClassLoader currentClassLoader();

   protected Class currentLoadedClass() {
      return this.currentLoadedClass0();
   }

   protected native int classDepth(String var1);

   protected native int classLoaderDepth();

   protected boolean inClass(String var1) {
      return this.classDepth(var1) >= 0;
   }

   protected boolean inClassLoader() {
      return this.currentClassLoader() != null;
   }

   public Object getSecurityContext() {
      return null;
   }

   public void checkCreateClassLoader() {
      throw new SecurityException();
   }

   public void checkAccess(Thread var1) {
      throw new SecurityException();
   }

   public void checkAccess(ThreadGroup var1) {
      throw new SecurityException();
   }

   public void checkExit(int var1) {
      throw new SecurityException();
   }

   public void checkExec(String var1) {
      throw new SecurityException();
   }

   public void checkLink(String var1) {
      throw new SecurityException();
   }

   public void checkRead(FileDescriptor var1) {
      throw new SecurityException();
   }

   public void checkRead(String var1) {
      throw new SecurityException();
   }

   public void checkRead(String var1, Object var2) {
      throw new SecurityException();
   }

   public void checkWrite(FileDescriptor var1) {
      throw new SecurityException();
   }

   public void checkWrite(String var1) {
      throw new SecurityException();
   }

   public void checkDelete(String var1) {
      throw new SecurityException();
   }

   public void checkConnect(String var1, int var2) {
      throw new SecurityException();
   }

   public void checkConnect(String var1, int var2, Object var3) {
      throw new SecurityException();
   }

   public void checkListen(int var1) {
      throw new SecurityException();
   }

   public void checkAccept(String var1, int var2) {
      throw new SecurityException();
   }

   public void checkMulticast(InetAddress var1) {
      throw new SecurityException();
   }

   public void checkMulticast(InetAddress var1, byte var2) {
      throw new SecurityException();
   }

   public void checkPropertiesAccess() {
      throw new SecurityException();
   }

   public void checkPropertyAccess(String var1) {
      throw new SecurityException();
   }

   public boolean checkTopLevelWindow(Object var1) {
      return false;
   }

   public void checkPrintJobAccess() {
      throw new SecurityException();
   }

   public void checkSystemClipboardAccess() {
      throw new SecurityException();
   }

   public void checkAwtEventQueueAccess() {
      throw new SecurityException();
   }

   public void checkPackageAccess(String var1) {
      throw new SecurityException();
   }

   public void checkPackageDefinition(String var1) {
      throw new SecurityException();
   }

   public void checkSetFactory() {
      throw new SecurityException();
   }

   public void checkMemberAccess(Class var1, int var2) {
      throw new SecurityException();
   }

   public void checkSecurityAccess(String var1) {
      throw new SecurityException();
   }

   private native Class currentLoadedClass0();

   public ThreadGroup getThreadGroup() {
      return Thread.currentThread().getThreadGroup();
   }
}
