package java.lang;

public final class Short extends Number {
   public static final short MIN_VALUE = -32768;
   public static final short MAX_VALUE = 32767;
   public static final Class TYPE = Class.getPrimitiveClass("short");
   private short value;

   public static String toString(short var0) {
      return Integer.toString(var0, 10);
   }

   public static short parseShort(String var0) throws NumberFormatException {
      return parseShort(var0, 10);
   }

   public static short parseShort(String var0, int var1) throws NumberFormatException {
      int var2 = Integer.parseInt(var0, var1);
      if (var2 >= -32768 && var2 <= 32767) {
         return (short)var2;
      } else {
         throw new NumberFormatException();
      }
   }

   public static Short valueOf(String var0, int var1) throws NumberFormatException {
      return new Short(parseShort(var0, var1));
   }

   public static Short valueOf(String var0) throws NumberFormatException {
      return valueOf(var0, 10);
   }

   public static Short decode(String var0) throws NumberFormatException {
      if (var0.startsWith("0x")) {
         return valueOf(var0.substring(2), 16);
      } else if (var0.startsWith("#")) {
         return valueOf(var0.substring(1), 16);
      } else {
         return var0.startsWith("0") && var0.length() > 1 ? valueOf(var0.substring(1), 8) : valueOf(var0);
      }
   }

   public Short(short var1) {
      this.value = var1;
   }

   public Short(String var1) throws NumberFormatException {
      this.value = parseShort(var1);
   }

   public byte byteValue() {
      return (byte)this.value;
   }

   public short shortValue() {
      return this.value;
   }

   public int intValue() {
      return this.value;
   }

   public long longValue() {
      return (long)this.value;
   }

   public float floatValue() {
      return (float)this.value;
   }

   public double doubleValue() {
      return (double)this.value;
   }

   public String toString() {
      return String.valueOf(this.value);
   }

   public int hashCode() {
      return this.value;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Short) {
         return this.value == (Short)var1;
      } else {
         return false;
      }
   }
}
