package java.lang;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Properties;

public final class System {
   // $FF: renamed from: in java.io.InputStream
   public static final InputStream field_0 = nullInputStream();
   public static final PrintStream out = nullPrintStream();
   public static final PrintStream err = nullPrintStream();
   private static SecurityManager security = null;
   private static Properties props;

   private System() {
   }

   public static void setIn(InputStream var0) {
      checkIO();
      setIn0(var0);
   }

   public static void setOut(PrintStream var0) {
      checkIO();
      setOut0(var0);
   }

   public static void setErr(PrintStream var0) {
      checkIO();
      setErr0(var0);
   }

   private static void checkIO() {
      if (security != null) {
         security.checkExec("setio");
      }

   }

   private static native void setIn0(InputStream var0);

   private static native void setOut0(PrintStream var0);

   private static native void setErr0(PrintStream var0);

   public static void setSecurityManager(SecurityManager var0) {
      if (security != null) {
         throw new SecurityException("SecurityManager already set");
      } else {
         security = var0;
      }
   }

   public static SecurityManager getSecurityManager() {
      return security;
   }

   public static native long currentTimeMillis();

   public static native void arraycopy(Object var0, int var1, Object var2, int var3, int var4);

   public static native int identityHashCode(Object var0);

   private static native Properties initProperties(Properties var0);

   public static Properties getProperties() {
      if (security != null) {
         security.checkPropertiesAccess();
      }

      return props;
   }

   public static void setProperties(Properties var0) {
      if (security != null) {
         security.checkPropertiesAccess();
      }

      props = var0;
   }

   public static String getProperty(String var0) {
      if (security != null) {
         security.checkPropertyAccess(var0);
      }

      return props.getProperty(var0);
   }

   public static String getProperty(String var0, String var1) {
      if (security != null) {
         security.checkPropertyAccess(var0);
      }

      return props.getProperty(var0, var1);
   }

   /** @deprecated */
   public static String getenv(String var0) {
      throw new Error("getenv no longer supported, use properties and -D instead: " + var0);
   }

   public static void exit(int var0) {
      Runtime.getRuntime().exit(var0);
   }

   // $FF: renamed from: gc () void
   public static void method_0() {
      Runtime.getRuntime().gc();
   }

   public static void runFinalization() {
      Runtime.getRuntime().runFinalization();
   }

   public static void runFinalizersOnExit(boolean var0) {
      Runtime.getRuntime();
      Runtime.runFinalizersOnExit(var0);
   }

   public static void load(String var0) {
      Runtime.getRuntime().load(var0);
   }

   public static void loadLibrary(String var0) {
      Runtime.getRuntime().loadLibrary(var0);
   }

   private static InputStream nullInputStream() throws NullPointerException {
      if (currentTimeMillis() > 0L) {
         return null;
      } else {
         throw new NullPointerException();
      }
   }

   private static PrintStream nullPrintStream() throws NullPointerException {
      if (currentTimeMillis() > 0L) {
         return null;
      } else {
         throw new NullPointerException();
      }
   }

   private static void initializeSystemClass() {
      props = new Properties();
      initProperties(props);
      FileInputStream var0 = new FileInputStream(FileDescriptor.in);
      FileOutputStream var1 = new FileOutputStream(FileDescriptor.out);
      FileOutputStream var2 = new FileOutputStream(FileDescriptor.err);
      setIn0(new BufferedInputStream(var0));
      setOut0(new PrintStream(new BufferedOutputStream(var1, 128), true));
      setErr0(new PrintStream(new BufferedOutputStream(var2, 128), true));
   }
}
