package java.lang;

import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Serializable;

public class Throwable implements Serializable {
   private transient Object backtrace;
   private String detailMessage;
   private static final long serialVersionUID = -3042686055658047285L;

   public Throwable() {
      this.fillInStackTrace();
   }

   public Throwable(String var1) {
      this.fillInStackTrace();
      this.detailMessage = var1;
   }

   public String getMessage() {
      return this.detailMessage;
   }

   public String getLocalizedMessage() {
      return this.getMessage();
   }

   public String toString() {
      String var1 = this.getClass().getName();
      String var2 = this.getMessage();
      return var2 != null ? var1 + ": " + var2 : var1;
   }

   public void printStackTrace() {
      System.err.println(this);
      this.printStackTrace0(System.err);
   }

   public void printStackTrace(PrintStream var1) {
      var1.println(this);
      this.printStackTrace0(var1);
   }

   public void printStackTrace(PrintWriter var1) {
      var1.println(this);
      this.printStackTrace0(var1);
   }

   private native void printStackTrace0(Object var1);

   public native Throwable fillInStackTrace();
}
