package java.lang.reflect;

public class Modifier {
   public static final int PUBLIC = 1;
   public static final int PRIVATE = 2;
   public static final int PROTECTED = 4;
   public static final int STATIC = 8;
   public static final int FINAL = 16;
   public static final int SYNCHRONIZED = 32;
   public static final int VOLATILE = 64;
   public static final int TRANSIENT = 128;
   public static final int NATIVE = 256;
   public static final int INTERFACE = 512;
   public static final int ABSTRACT = 1024;

   public static boolean isPublic(int var0) {
      return (var0 & 1) != 0;
   }

   public static boolean isPrivate(int var0) {
      return (var0 & 2) != 0;
   }

   public static boolean isProtected(int var0) {
      return (var0 & 4) != 0;
   }

   public static boolean isStatic(int var0) {
      return (var0 & 8) != 0;
   }

   public static boolean isFinal(int var0) {
      return (var0 & 16) != 0;
   }

   public static boolean isSynchronized(int var0) {
      return (var0 & 32) != 0;
   }

   public static boolean isVolatile(int var0) {
      return (var0 & 64) != 0;
   }

   public static boolean isTransient(int var0) {
      return (var0 & 128) != 0;
   }

   public static boolean isNative(int var0) {
      return (var0 & 256) != 0;
   }

   public static boolean isInterface(int var0) {
      return (var0 & 512) != 0;
   }

   public static boolean isAbstract(int var0) {
      return (var0 & 1024) != 0;
   }

   public static String toString(int var0) {
      StringBuffer var1 = new StringBuffer();
      if ((var0 & 1) != 0) {
         var1.append("public ");
      }

      if ((var0 & 2) != 0) {
         var1.append("private ");
      }

      if ((var0 & 4) != 0) {
         var1.append("protected ");
      }

      if ((var0 & 1024) != 0) {
         var1.append("abstract ");
      }

      if ((var0 & 8) != 0) {
         var1.append("static ");
      }

      if ((var0 & 16) != 0) {
         var1.append("final ");
      }

      if ((var0 & 128) != 0) {
         var1.append("transient ");
      }

      if ((var0 & 64) != 0) {
         var1.append("volatile ");
      }

      if ((var0 & 256) != 0) {
         var1.append("native ");
      }

      if ((var0 & 32) != 0) {
         var1.append("synchronized ");
      }

      if ((var0 & 512) != 0) {
         var1.append("interface ");
      }

      int var2;
      return (var2 = var1.length()) > 0 ? var1.toString().substring(0, var2 - 1) : "";
   }
}
